%global namedreltag .Final
%global namedversion %{version}%{?namedreltag}

Name:          ironjacamar
Version:       1.3.4
Release:       2%{?dist}
Summary:       Java Connector Architecture 1.7 implementation
License:       LGPLv2+
URL:           http://www.ironjacamar.org/
Source0:       https://github.com/ironjacamar/ironjacamar/archive/%{name}-%{namedversion}.tar.gz

# Commented out trying to download Ivy from the Internet
Patch0:        ironjacamar-1.3.4.Final-Use-Fedora-provided-IVY.patch
Patch1:        0002-Adjust-IVY-paths.patch
Patch2:        ironjacamar-1.3.4-remove-ambiguous-reference-to-tracef.patch   

BuildRequires: ant
BuildRequires: apache-ivy
BuildRequires: graphviz
BuildRequires: ivy-local
BuildRequires: java-devel
BuildRequires: javapackages-local
BuildRequires: mvn(javax.validation:validation-api)
BuildRequires: mvn(jdepend:jdepend)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.jboss:jandex)
BuildRequires: mvn(org.jboss:jboss-transaction-spi)
BuildRequires: mvn(org.jboss.apiviz:apiviz)
BuildRequires: mvn(org.jboss.jdeparser:jdeparser)
BuildRequires: mvn(org.jboss.logging:jboss-logging)
BuildRequires: mvn(org.jboss.logging:jboss-logging-annotations)
BuildRequires: mvn(org.jboss.logging:jboss-logging-processor)
BuildRequires: mvn(org.jboss.logmanager:jboss-logmanager)
BuildRequires: mvn(org.jboss.logmanager:log4j-jboss-logmanager)
BuildRequires: mvn(org.jboss.spec.javax.security.auth.message:jboss-jaspi-api_1.0_spec)
BuildRequires: mvn(org.jboss.spec.javax.transaction:jboss-transaction-api_1.2_spec)
BuildRequires: mvn(org.jboss.threads:jboss-threads)
BuildRequires: mvn(org.jgroups:jgroups)
BuildRequires: mvn(org.picketbox:picketbox)

# Runtime dependecies
Requires:      java-headless
Requires:      javapackages-tools
Requires:      mvn(javax.validation:validation-api)
Requires:      mvn(org.jboss:jandex)
Requires:      mvn(org.jboss:jboss-transaction-spi)
Requires:      mvn(org.jboss.logging:jboss-logging)
Requires:      mvn(org.jboss.spec.javax.security.auth.message:jboss-jaspi-api_1.0_spec)
Requires:      mvn(org.jboss.spec.javax.transaction:jboss-transaction-api_1.2_spec)
Requires:      mvn(org.jboss.threads:jboss-threads)
Requires:      mvn(org.jboss.logmanager:log4j-jboss-logmanager)
Requires:      mvn(org.picketbox:picketbox)

BuildArch:     noarch

%description
The IronJacamar project implements the Java Connector Architecture 1.7
specification.

The Java Connector Architecture (JCA) defines a standard architecture for
connecting the Java EE platform to heterogeneous Enterprise Information
Systems (EIS). Examples of EISs include Enterprise Resource Planning (ERP),
mainframe transaction processing (TP), database and messaging systems.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -qn %{name}-%{name}-%{namedversion}
# Cleanup
find -name "*.class" -print -delete
find -name "*.jar" -print -delete

%patch0 -p1
%patch1 -p1
%patch2 -p1

# Fixing JDK7 ASCII issues
files='
api/src/main/java/javax/resource/spi/BootstrapContext.java
api/src/main/java/javax/resource/spi/work/SecurityContext.java
'

for f in ${files}; do
  native2ascii -encoding UTF8 ${f} ${f}
done

# Rename the license file
cp -r doc/licenses/lgpl-2.1.txt LICENSE.txt

mkdir lib

sed -i '/IronJacamar requires JDK7/d' build.xml
sed -i '/Nexus requires JDK7/d' build.xml
sed -i '/<deploy-file/d' build.xml
sed -i '/<install-file/d' build.xml

%build

ant -Divy.mode=local -Das jars-base clean docs nexus-base

# Fix malformed pom entries
%pom_change_dep org.jboss.spec.javax.transaction: :jboss-transaction-api_1.2_spec target/%{name}-core-api.xml
%pom_change_dep javax.validation: :validation-api target/%{name}-core-impl.xml
%pom_change_dep org.jboss.spec.javax.security.auth.message: :jboss-jaspi-api_1.0_spec target/%{name}-core-impl.xml
%pom_change_dep org.jboss.spec.javax.transaction: :jboss-transaction-api_1.2_spec target/%{name}-core-impl.xml
%pom_change_dep org.jboss.spec.javax.transaction: :jboss-transaction-api_1.2_spec target/%{name}-jdbc.xml
%pom_change_dep org.jboss.spec.javax.transaction: :jboss-transaction-api_1.2_spec target/%{name}-spec-api.xml

%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name} \
         $RPM_BUILD_ROOT%{_mavenpomdir} \
         $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# common-impl-papaki validator-cli validator-maven validator-ant - not built in when nexus/brew target is selected
# deployers-fungal - no fungal package available
for m in common-api common-impl common-spi core-api core-impl deployers-common jdbc spec-api validator; do
# JAR
  install -pm 644 target/%{name}-${m}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-${m}.jar
# POM
  install -pm 644 target/%{name}-${m}.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP.%{name}-%{name}-${m}.pom
# DEPMAP
  %add_maven_depmap JPP.%{name}-%{name}-${m}.pom %{name}/%{name}-${m}.jar
done
# APIDOCS
cp -rp target/docs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%files -f .mfiles
%doc README.md
%license LICENSE.txt

%files javadoc
%{_javadocdir}/%{name}
%license LICENSE.txt

%changelog
* Tue Aug 09 2016 gil cattaneo <puntogil@libero.it> 1.3.4-2
- add missing build requires: ant

* Fri Jul 01 2016 gil cattaneo <puntogil@libero.it> 1.3.4-1
- Updated to 1.3.4.Final

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Jul 20 2015 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 1.1.10-1
- Update to version 1.1.10, it was just released

* Mon Jul 20 2015 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 1.1.9-1
- Update to latest release of 1.1.x branch (#1239580, #1108527)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.1.3-2
- Use Requires: java-headless rebuild (#1067528)

* Fri Feb 14 2014 Marek Goldmann <mgoldman@redhat.com> - 1.1.3-1
- Upstream release 1.1.3.Final

* Fri Dec 13 2013 Marek Goldmann <mgoldman@redhat.com> - 1.1.2-1
- Upstream release 1.1.2.Final

* Wed Oct 23 2013 Ricardo Arguello <ricardo@fedoraproject.org> - 1.1.0-3
- Added a patch to fix a field type in JBJCA-1068
- Include connector_1_0.dtd since it fixed its license in JBJCA-775

* Tue Oct 22 2013 Marek Goldmann <mgoldman@redhat.com> - 1.1.0-2
- Make adapters module work too

* Tue Oct 22 2013 Marek Goldmann <mgoldman@redhat.com> - 1.1.0-1
- Upstream release 1.1.0.Final

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.19-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 12 2013 Marek Goldmann <mgoldman@redhat.com> - 1.0.19-1
- Upstream release 1.0.19.Final

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 1.0.9-5
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Mar 27 2012 Ricardo Arguello <ricardo@fedoraproject.org> 1.0.9-3
- Added a patch to remove the Class-Path directive in the Manifest of the ironjacamar-validator.jar file
- Removed the file 'common/src/main/resources/dtd/connector_1_0.dtd' because of restrictive license
- Added missing license file

* Tue Mar 27 2012 Ricardo Arguello <ricardo@fedoraproject.org> 1.0.9-2
- Commented out trying to download Ivy from the Internet

* Sat Mar 24 2012 Ricardo Arguello <ricardo@fedoraproject.org> 1.0.9-1
- Updated to 1.0.9 from upstream
- Use JAR filenames assigned by the build

* Fri Mar 9 2012 Ricardo Arguello <ricardo@fedoraproject.org> 1.0.7-3
- Cleanup of the spec file

* Thu Mar 08 2012 Marek Goldmann <mgoldman@redhat.com> 1.0.7-2
- Correct way of executing the build

* Fri Feb 24 2012 Marek Goldmann <mgoldman@redhat.com> 1.0.7-1
- Initial packaging
